unit uAnalogUhr1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,uTUhr2,ExtCtrls;

type
  TForm1 = class(TForm)
    eH: TEdit; eMin: TEdit; eSec: TEdit; L1: TLabel; L2: TLabel;
    bSetzen: TButton; lAusgabe: TLabel; Timer1: TTimer; IUhr: TImage;
    procedure bSetzenClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure aktualisiere;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses uAnalogUhr2, uAnalogUhr3;
{$R *.DFM}

procedure Uhr2Winkel(h,min,sec : byte; var wh,wmin,wsec : real);
begin
  h := h mod 12; // 24h-Anzeige --> 12h-Anzeige
  wh   := pi/2 - 2*pi/12/60*(60*h+min);
  wmin := pi/2 - 2*pi/60*min;
  wsec := pi/2 - 2*pi/60*sec;
end;

procedure zeichneUhr;
var
  mx,my,r,ax,ay,ex,ey : word;
  i,h,min,sec         : byte;
  wh,wmin,wsec        : real;
begin
  mx := Form1.IUhr.Width div 2; my := Form1.IUhr.Height div 2;
  if mx < my then r := mx else r := my; r := r-3;
  // alles lschen
  Form1.IUhr.canvas.RectAngle(0,0,Form1.IUhr.width,Form1.IUhr.height);
  // Zifferblatt zeichnen
  for i := 1 to 12 do
  begin
    Uhr2Winkel(i,0,0,wh,wmin,wsec);
    ax := Round(mx+r*0.8*cos(wh)); ay := Round(my-r*0.8*sin(wh));
    ex := Round(mx+r*cos(wh)); ey := Round(my-r*sin(wh));
    Form1.IUhr.Canvas.MoveTo(ax,ay); Form1.IUhr.Canvas.LineTo(ex,ey);
  end;
  // Zeit auslesen und Winkel berechnen
  h := oUhr.GetH; min := oUhr.GetMin; sec := oUhr.GetSec;
  Uhr2Winkel(h,min,sec,wh,wmin,wsec);
  // Stundenzeiger
  Form1.IUhr.canvas.Pen.Width := 2;
  ex := Round(mx+r*0.65*cos(wh)); ey := Round(my-r*0.65*sin(wh));
  Form1.IUhr.Canvas.MoveTo(mx,my); Form1.IUhr.Canvas.LineTo(ex,ey);
  // Minutenzeiger
  ex := Round(mx+r*0.9*cos(wmin)); ey := Round(my-r*0.9*sin(wmin));
  Form1.IUhr.Canvas.MoveTo(mx,my); Form1.IUhr.Canvas.LineTo(ex,ey);
  // Sekundenzeiger
  Form1.IUhr.canvas.Pen.Width := 1;
  ex := Round(mx+r*0.98*cos(wsec)); ey := Round(my-r*0.98*sin(wsec));
  Form1.IUhr.Canvas.MoveTo(mx,my); Form1.IUhr.Canvas.LineTo(ex,ey);
end;

procedure aktualisiereAusgabe;
var
  hs,mins,secs : string;
begin
  hs := IntToStr(oUhr.GetH); if Length(hs) < 2 then hs := '0'+hs;
  mins := IntToStr(oUhr.GetMin); if Length(mins) < 2 then mins := '0'+mins;
  secs := IntToStr(oUhr.GetSec); if Length(secs) < 2 then secs := '0'+secs;
  Form1.lAusgabe.caption := hs+':'+mins+':'+secs;
  zeichneUhr;
end;

procedure TForm1.bSetzenClick(Sender: TObject);
var
  h,min,sec : byte;
begin
  h := StrToInt(eH.text); min := StrToInt(eMin.text); sec := StrToInt(eSec.text);
  oUhr.SetH(h); oUhr.SetMin(min); oUhr.SetSec(sec);
end;

procedure TForm1.aktualisiere;
begin
  aktualisiereAusgabe;
  Form2.aktualisiereAusgabe;
  Form3.aktualisiereAusgabe;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  oUhr.IncSec;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  oUhr.Onchange := aktualisiere;
end;

end.
