unit uTUhr2;

interface

uses
  SysUtils,extCtrls;

type
  TEreignis = procedure of object;

  TUhr = class(TObject)
  private
    Ft : TDateTime;
  public
    Onchange : TEreignis;
    procedure SetH(h : byte);
    procedure SetMin(min : byte);
    procedure SetSec(sec : byte);
    function GetH : byte;
    function GetMin : byte;
    function GetSec : byte;
    procedure IncSec;
  end;

var
  oUhr : TUhr;

implementation

procedure TUhr.SetH(h : byte);
var
  min,sec : byte;
begin
  min := GetMin; sec := GetSec;
  Ft := EncodeTime(h,min,sec,0);
  if Assigned(OnChange) then Onchange;
end;

procedure TUhr.SetMin(min : byte);
var
  h,sec : byte;
begin
  h := GetH; sec := GetSec;
  Ft := EncodeTime(h,min,sec,0);
  if Assigned(OnChange) then Onchange;
end;

procedure TUhr.SetSec(sec : byte);
var
  h,min : byte;
begin
  h := GetH; min := GetMin;
  Ft := EncodeTime(h,min,sec,0);
  if Assigned(OnChange) then Onchange;
end;

function TUhr.GetH : byte;
var
  h,min,sec,msec : word;
begin
  DecodeTime(Ft,h,min,sec,msec);
  Result := h;
end;

function TUhr.GetMin : byte;
var
  h,min,sec,msec : word;
begin
  DecodeTime(Ft,h,min,sec,msec);
  Result := min;
end;

function TUhr.GetSec : byte;
var
  h,min,sec,msec : word;
begin
  DecodeTime(Ft,h,min,sec,msec);
  Result := sec;
end;

procedure TUhr.IncSec;
var
  h,min,sec,msec : word;
begin
  DecodeTime(Ft,h,min,sec,msec);
  if sec < 59
  then Ft := EncodeTime(h,min,sec+1,0)
  else
    if min < 59
    then Ft := EncodeTime(h,min+1,0,0)
    else
      if h < 23
      then Ft := EncodeTime(h+1,0,0,0)
      else Ft := EncodeTime(0,0,0,0);
  if Assigned(OnChange) then Onchange;
end;

initialization
  oUhr := TUhr.Create;
finalization
  oUhr.free;
end.
